Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs	(revision 5779)
@@ -45,4 +45,5 @@
           else if (job.State == JobState.Calculating) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStarted;
           else if (job.State == JobState.Transferring) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStarted;
+          else if (job.State == JobState.Paused) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutablePaused;
           else if (job.State == JobState.Aborted) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStopped;
           else if (job.State == JobState.Failed) return HeuristicLab.Common.Resources.VSImageLibrary.Error;
@@ -604,4 +605,16 @@
     }
     #endregion
+
+    public void Pause() {
+      ServiceLocator.Instance.CallHiveService(s => s.PauseJob(this.job.Id));
+    }
+
+    public void Stop() {
+      ServiceLocator.Instance.CallHiveService(s => s.StopJob(this.job.Id));
+    }
+
+    public void Restart() {
+      ServiceLocator.Instance.CallHiveService(s => s.RestartJob(this.job.Id));
+    }
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj	(revision 5779)
@@ -139,4 +139,5 @@
     <Compile Include="Exceptions\ServiceClientFactoryException.cs" />
     <Compile Include="ServiceClients\Appointment.cs" />
+    <Compile Include="ServiceClients\NamedHiveItem.cs" />
     <Compile Include="ServiceClients\Heartbeat.cs" />
     <Compile Include="ServiceClients\HiveExperimentPermission.cs" />
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Appointment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Appointment.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Appointment.cs	(revision 5779)
@@ -27,5 +27,6 @@
     public Appointment() { }
 
-    protected Appointment(Appointment original, Cloner cloner) {
+    protected Appointment(Appointment original, Cloner cloner)
+      : base(original, cloner) {
       this.AllDayEvent = original.AllDayEvent;
       this.EndDate = original.EndDate;
@@ -34,5 +35,4 @@
       this.ResourceId = original.ResourceId;
       this.StartDate = original.StartDate;
-      this.Id = original.Id;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperiment.cs	(revision 5779)
@@ -29,4 +29,5 @@
 
     protected HiveExperiment(HiveExperiment original, Cloner cloner) {
+      cloner.RegisterClonedObject(original, this);
       this.RootJobId = original.RootJobId;
       this.OwnerUserId = original.OwnerUserId;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperimentPermission.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperimentPermission.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/HiveExperimentPermission.cs	(revision 5779)
@@ -29,9 +29,5 @@
 
     protected HiveExperimentPermission(HiveExperimentPermission original, Cloner cloner) {
-      /*this.HiveExperimentId = original.HiveExperimentId;
-      this.GrantedUserId = original.GrantedUserId;
-      this.GrantedByUserId = original.GrantedByUserId;
-      this.Permission = original.Permission;
-      this.Id = original.Id;*/
+      cloner.RegisterClonedObject(original, this);
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Job.cs	(revision 5779)
@@ -30,5 +30,5 @@
     public Job() { }
 
-    protected Job(Job original, Cloner cloner) {
+    protected Job(Job original, Cloner cloner) : base(original, cloner) {
       this.Priority = original.Priority;
       this.CoresNeeded = original.CoresNeeded;
@@ -38,9 +38,4 @@
       this.IsParentJob = original.IsParentJob;
       this.FinishWhenChildJobsFinished = original.FinishWhenChildJobsFinished;
-      this.ExecutionTime = original.ExecutionTime;
-      this.ParentJobId = original.ParentJobId;
-      this.StateLog = new List<StateLog>(original.StateLog);
-      this.State = original.State;
-      this.Id = original.Id;
     }
 
@@ -50,5 +45,10 @@
 
     public override string ToString() {
-      return string.Format("State: {0}, SlaveId: {1}, DateCreated: {2}, DateCalculated: {3}, CoresNeeded: {4}, MemoryNeeded: {5}", State, CurrentStateLog.SlaveId, DateCreated.HasValue ? DateCreated.ToString() : "-", CoresNeeded, MemoryNeeded);
+      return string.Format("State: {0}, SlaveId: {1}, DateCreated: {2}, CoresNeeded: {3}, MemoryNeeded: {4}", 
+        State, 
+        CurrentStateLog != null ? (CurrentStateLog.SlaveId.HasValue ? CurrentStateLog.SlaveId.Value.ToString() : string.Empty) : string.Empty, 
+        DateCreated.HasValue ? DateCreated.ToString() : string.Empty, 
+        CoresNeeded, 
+        MemoryNeeded);
     }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/JobData.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/JobData.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/JobData.cs	(revision 5779)
@@ -29,4 +29,5 @@
 
     protected JobData(JobData original, Cloner cloner) {
+      cloner.RegisterClonedObject(original, this);
       if (original.Data != null) this.Data = new byte[original.Data.Length]; Array.Copy(original.Data, this.Data, original.Data.Length);
       this.LastUpdate = original.LastUpdate;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/LightweightJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/LightweightJob.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/LightweightJob.cs	(revision 5779)
@@ -42,12 +42,14 @@
       this.StateLog = new List<StateLog>(job.StateLog);
       this.State = job.State;
+      this.Command = job.Command;
     }
 
-    protected LightweightJob(LightweightJob original, Cloner cloner) {
+    protected LightweightJob(LightweightJob original, Cloner cloner)
+      : base(original, cloner) {
       this.ExecutionTime = original.ExecutionTime;
       this.ParentJobId = original.ParentJobId;
       this.StateLog = new List<StateLog>(original.StateLog);
       this.State = original.State;
-      this.Id = original.Id;
+      this.Command = original.Command;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/NamedHiveItem.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/NamedHiveItem.cs	(revision 5779)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/NamedHiveItem.cs	(revision 5779)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive {
+
+  public partial class NamedHiveItem : HiveItem {
+
+    public NamedHiveItem() { }
+
+    protected NamedHiveItem(NamedHiveItem original, Cloner cloner) : base(original, cloner) {
+      this.Name = original.Name;
+      this.Description = original.Description;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new NamedHiveItem(this, cloner);
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Plugin.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Plugin.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Plugin.cs	(revision 5779)
@@ -20,22 +20,18 @@
 #endregion
 
-using System;
-using System.Runtime.Serialization;
 using HeuristicLab.Common;
 
 namespace HeuristicLab.Clients.Hive {
-  
+
   public partial class Plugin : IDeepCloneable, IContent {
 
     public Plugin() { }
 
-    protected Plugin(Plugin original, Cloner cloner) {
+    protected Plugin(Plugin original, Cloner cloner)
+      : base(original, cloner) {
       this.Version = original.Version;
       this.UserId = original.UserId;
       this.DateCreated = original.DateCreated;
       this.IsLocal = original.IsLocal;
-      this.Name = original.Name;
-      this.Description = original.Description;
-      this.Id = original.Id;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/PluginData.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/PluginData.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/PluginData.cs	(revision 5779)
@@ -29,5 +29,6 @@
     public PluginData() { }
 
-    protected PluginData(PluginData original, Cloner cloner) {
+    protected PluginData(PluginData original, Cloner cloner) 
+      : base(original, cloner) {
       if (original.Data != null)
         this.Data = new byte[original.Data.Length];
@@ -35,5 +36,4 @@
       this.FileName = original.FileName;
       this.PluginId = original.PluginId;
-      this.Id = original.Id;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Resource.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Resource.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/Resource.cs	(revision 5779)
@@ -28,9 +28,7 @@
     public Resource() { }
 
-    protected Resource(Resource original, Cloner cloner) {
+    protected Resource(Resource original, Cloner cloner) 
+      : base(original, cloner) {
       this.ParentResourceId = original.ParentResourceId;
-      this.Name = original.Name;
-      this.Description = original.Description;
-      this.Id = original.Id;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/StateLog.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/StateLog.cs	(revision 5718)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/StateLog.cs	(revision 5779)
@@ -28,5 +28,6 @@
     public StateLog() { }
 
-    protected StateLog(StateLog original, Cloner cloner) {
+    protected StateLog(StateLog original, Cloner cloner)
+      : base(original, cloner) {
       this.DateTime = original.DateTime;
       this.UserId = original.UserId;
@@ -35,5 +36,4 @@
       this.State = original.State;
       this.JobId = original.JobId;
-      this.Id = original.Id;
     }
 
